import { parse_txin, parse_txout } from './tx.js';
import { encode_tx, parse_tx } from '@scrow/tapscript/tx';
import PSBTSchema from '../schema.js';
export function create_psbt(tx) {
    const global = [], inputs = [], outputs = [];
    const txdata = parse_tx(tx);
    const txbase = encode_tx(txdata, true).hex;
    for (const txin of txdata.vin) {
        inputs.push(parse_txin(txin));
    }
    for (const txout of txdata.vout) {
        outputs.push(parse_txout(txout));
    }
    global.push({ label: 'UNSIGNED_TX', value: txbase });
    return PSBTSchema.data.parse({ global, inputs, outputs });
}
