import { normalize_psbt } from './parse.js';
import { parse_txin } from './tx.js';
import { assert } from '../util/index.js';
import PSBTSchema from '../schema.js';
export function update_psbt(psbt, templ) {
    const data = normalize_psbt(psbt);
    const { global, inputs, outputs } = data;
    global.push(...templ.global ?? []);
    inputs.push(...templ.inputs ?? []);
    outputs.push(...templ.outputs ?? []);
    return PSBTSchema.data.parse({ global, inputs, outputs });
}
export function add_psbt_utxo(psbt, utxo, index = 0) {
    const data = normalize_psbt(psbt);
    const { global, inputs, outputs } = data;
    assert.ok(data.inputs.length > index, 'index exceeds psbt input count');
    inputs[index] = parse_txin(utxo);
    return PSBTSchema.data.parse({ global, inputs, outputs });
}
